#ifndef HEPVis_SbTessContour_h
#define HEPVis_SbTessContour_h

#include <vector>
#include <Inventor/SbLinear.h>

typedef struct {
  double pointA[3];
  double pointB[3];
  double pointC[3];
} SbTessTriangle;

class SbTessContour {  
public:
  SbTessContour();
  virtual ~SbTessContour();
public:
  std::vector<SbTessTriangle> getFilledArea(const std::vector<std::vector<SbVec3f> >);
public:
  void resetVertex();
  void addVertex(const double*);
  void setBeginType(int);
  void setError(bool);
  std::vector<double*>& combineTmps();
private:
  SbTessTriangle fTmp;
  unsigned int fVertexNumber;
  int fBeginType;
  bool fError;
  std::vector<SbTessTriangle> fTriangles;
  std::vector<double*> fCombineTmps;
};

#endif
