#ifndef Lib_Upgrader_h
#define Lib_Upgrader_h

#include <string>
#include <vector>

namespace Slash {namespace Core {class IWriter;}}

namespace Lib {

class Upgrader {
public:
  Upgrader(Slash::Core::IWriter&,int,const std::string&);
  Upgrader(const Upgrader&);
  virtual ~Upgrader();
  Upgrader& operator =(const Upgrader&);
  bool upgrade(const std::string&);
  bool upgradeFile(const std::string&);
  bool upgradeDirectory(const std::string&);
  int verboseLevel() const;
private:
  Slash::Core::IWriter& fPrinter;
  int fVerboseLevel;
  std::vector<std::string> fOrders;
};

}

#endif
